/*
Copyright 2020 The Tekton Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	pipelinev1alpha1 "github.com/tektoncd/pipeline/pkg/apis/pipeline/v1alpha1"
	labels "k8s.io/apimachinery/pkg/labels"
	listers "k8s.io/client-go/listers"
	cache "k8s.io/client-go/tools/cache"
)

// VerificationPolicyLister helps list VerificationPolicies.
// All objects returned here must be treated as read-only.
type VerificationPolicyLister interface {
	// List lists all VerificationPolicies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*pipelinev1alpha1.VerificationPolicy, err error)
	// VerificationPolicies returns an object that can list and get VerificationPolicies.
	VerificationPolicies(namespace string) VerificationPolicyNamespaceLister
	VerificationPolicyListerExpansion
}

// verificationPolicyLister implements the VerificationPolicyLister interface.
type verificationPolicyLister struct {
	listers.ResourceIndexer[*pipelinev1alpha1.VerificationPolicy]
}

// NewVerificationPolicyLister returns a new VerificationPolicyLister.
func NewVerificationPolicyLister(indexer cache.Indexer) VerificationPolicyLister {
	return &verificationPolicyLister{listers.New[*pipelinev1alpha1.VerificationPolicy](indexer, pipelinev1alpha1.Resource("verificationpolicy"))}
}

// VerificationPolicies returns an object that can list and get VerificationPolicies.
func (s *verificationPolicyLister) VerificationPolicies(namespace string) VerificationPolicyNamespaceLister {
	return verificationPolicyNamespaceLister{listers.NewNamespaced[*pipelinev1alpha1.VerificationPolicy](s.ResourceIndexer, namespace)}
}

// VerificationPolicyNamespaceLister helps list and get VerificationPolicies.
// All objects returned here must be treated as read-only.
type VerificationPolicyNamespaceLister interface {
	// List lists all VerificationPolicies in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*pipelinev1alpha1.VerificationPolicy, err error)
	// Get retrieves the VerificationPolicy from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*pipelinev1alpha1.VerificationPolicy, error)
	VerificationPolicyNamespaceListerExpansion
}

// verificationPolicyNamespaceLister implements the VerificationPolicyNamespaceLister
// interface.
type verificationPolicyNamespaceLister struct {
	listers.ResourceIndexer[*pipelinev1alpha1.VerificationPolicy]
}
